package ibase.webitm.ejb.adm;

import ibase.webitm.utility.*;
//import ibase.utility.CommonConstants;
import ibase.system.config.*;
//import java.text.*;
import java.util.*;
//import javax.xml.parsers.*;
import javax.ejb.*;
//import javax.naming.InitialContext;
import java.io.*;

import java.util.Calendar;
import java.util.Date;
import java.sql.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.rmi.RemoteException;
import org.w3c.dom.*;
import ibase.webitm.utility.ITMException;
import ibase.webitm.utility.GenericUtility;
import ibase.webitm.ejb.*;

import javax.ejb.Stateless; // added for ejb3


//public class SReturnPrsEJB extends ValidatorEJB implements SessionBean
@Stateless // added for ejb3
public class CopyGradeMthad extends ValidatorEJB implements CopyGradeMthadLocal, CopyGradeMthadRemote
{
	
	public String preSaveRec() throws RemoteException, ITMException
	{
		return "";
	}
	
	public String preSaveRec(String xmlString1, String domId, String objContext, String editFlag, String xtraParams, Connection conn) throws RemoteException, ITMException
	{
		System.out.println("@@@@@@@@********* CopyGradeMthad Called *******@@@@@@@@");
		Document dom = null;
		String errString = "";
		//ITMDBAccessEJB itmDBAccessLocal = new ITMDBAccessEJB();
		try
		{
			if (xmlString1 != null && xmlString1.trim().length() > 0)
			{
				dom = GenericUtility.getInstance().parseString(xmlString1);
				errString = executepreSaveRec(dom,domId,objContext,editFlag,xtraParams,conn);
				if (errString == null || errString.trim().length() == 0)
				{
					
					//errString = itmDBAccessLocal.getErrorString("","VTMCONF2","");
				}
				else
				{
					conn.rollback();
					//errString = itmDBAccessLocal.getErrorString("","VMPROCUSG","");
				}
			}
		}
		catch(Exception e)
		{
			System.out.println("Exception :CopyPayParamPrs :preSaveRec(): " + e.getMessage()+ ":");
			e.printStackTrace();
			throw new ITMException(e);
		}
		return errString;
	}
	private String executepreSaveRec(Document dom, String domID, String ObjContext, String editFlag, String xtraParams, Connection conn) throws RemoteException, ITMException
	{
		//Connection conn = null;
		PreparedStatement pstmt = null,pstmt1 = null,pstmtInser = null;
		ResultSet rs = null ,rs1 = null;
		String grade_code = "",new_grade_code="";
		String sql = "",sql1 = "",sqlInser;
		String chgUser = "",chgTerm = "",descr = "";
		//String grade_code="";
		String limit_type="";
		
		String month_code="",new_month_code="";
		String pay_table="";
		String gradeCode="";
		String new_pay_table="";
		String ad_code="";
		String eff_date="";
		String exp_date="";
		String type="";
		String prop_yn="";
		int amount=0;
		int min_basic=0;
		int max_basic=0;
		int min_amount=0;
		int max_amount=0;
		
		int cnt = 0,updCnt = 0;
		Date chgdate = null; 
		ITMDBAccessEJB itmDBAccessEJB = new ITMDBAccessEJB();
		GenericUtility genericUtility = GenericUtility.getInstance();		
		ITMDBAccessEJB itmDBAccessLocal = new ITMDBAccessEJB();
		String errString = "";
		boolean insertFlag=false;
		try
		{	
			ConnDriver connDriver = new ConnDriver();			
			conn = connDriver.getConnectDB("DriverITM");
			conn.setAutoCommit(false);
			pay_table = genericUtility.getColumnValue("pay_table",dom);
			//varName = genericUtility.getColumnValue("var_name",dom);
			new_pay_table = genericUtility.getColumnValue("new_pay_table",dom);
			new_grade_code = genericUtility.getColumnValue("new_grade_code",dom);
			new_month_code = genericUtility.getColumnValue("new_month_code",dom);
			gradeCode = genericUtility.getColumnValue("grade_code",dom);
			String currAppdate ="";
			java.sql.Timestamp currDate = null;
			Object date = null;
			currDate =new java.sql.Timestamp(System.currentTimeMillis()) ;
			System.out.println(genericUtility.getDBDateFormat());
			SimpleDateFormat sdf = new SimpleDateFormat(genericUtility.getDBDateFormat());
			date = sdf.parse(currDate.toString());
			currDate =	java.sql.Timestamp.valueOf(sdf.format(date).toString() + " 00:00:00.0");
			currAppdate = new SimpleDateFormat(genericUtility.getApplDateFormat()).format(currDate).toString();
			
			chgUser = genericUtility.getValueFromXTRA_PARAMS(xtraParams,"chg_user");
			
			chgTerm = genericUtility.getValueFromXTRA_PARAMS(xtraParams,"chg_term");
		
			
			if( pay_table == null || pay_table.trim().length() ==0 )
			{
				//errString = itmDBAccessEJB.getErrorString("","PRDCODNULL","");
				//return errString;
			}
			else if( new_pay_table == null || new_pay_table.trim().length() == 0 )
			{
				errString = itmDBAccessEJB.getErrorString("","NEWPAYTBL","");
				return errString;
			}
			else if( new_grade_code == null || new_grade_code.trim().length() == 0 )
			{
				errString = itmDBAccessEJB.getErrorString("","NEWGCNEMP","");
				return errString;
			}
			else if( new_month_code == null || new_month_code.trim().length() == 0 )
			{
				errString = itmDBAccessEJB.getErrorString("","NEWMCNEMP","");
				return errString;
			}
			else if( new_pay_table != null && new_pay_table.trim().length() > 0 )
			{
				/*if( new_pay_table.trim().length() > 5 )
				{
					
					errString = itmDBAccessEJB.getErrorString("","NEWSITEINV","");
            		return errString;
					
				}
				else if(checkValidity(new_pay_table, "pay_table", "paytable", conn)<=0){
					insertFlag=true;
					errString = itmDBAccessEJB.getErrorString("","NEWSITNEXI","");
	        		return errString;
				}*/
				
			}
			
			if(new_pay_table!=null && checkValidity(new_pay_table, "pay_table", "PAYTABLE", conn)<=0){
				//insertFlag=true;
				errString = itmDBAccessEJB.getErrorString("","NEWPAYNO","");
        		return errString;
			}
			
			if( new_grade_code !=null && checkValidity(new_grade_code, "GRADE_CODE", "GRADE", conn)<=0){
				//insertFlag=true;
				errString = itmDBAccessEJB.getErrorString("","GCNOEXIST","");
        		return errString;
			}
			
			if( new_month_code!=null ){
				//insertFlag=true;
				if(Integer.parseInt(new_month_code) <= 0 || Integer.parseInt(new_month_code) > 12){
					errString = itmDBAccessEJB.getErrorString("","MNCNOEXIST","");
	        		return errString;
				}
			}
			
			
			
			
			if( pay_table != null && pay_table != null && new_pay_table.trim().length() > 0 && pay_table.trim().length() > 0)
			{	
			//sql = " SELECT var_name,var_type,var_value,descr,var_subs FROM payrparm WHERE prd_code = ? ";   // and var_name = ?";
				
			sql =	"SELECT * FROM GRADE_MTHAD WHERE PAY_TABLE=? AND GRADE_CODE = ? AND MONTH_CODE = ?"; 
			pstmt =  conn.prepareStatement(sql);
			pstmt.setString(1,pay_table);
			pstmt.setString(2,gradeCode);
			pstmt.setString(3,new_month_code);
			//pstmt.setString(2,varName);
			rs = pstmt.executeQuery();
			while(rs.next())
			{
				System.out.println("inside rs");
				
				grade_code = rs.getString("grade_code");
				month_code= rs.getString("month_code");
				ad_code =rs.getString("ad_code");
				eff_date =rs.getString("eff_date");
				exp_date =rs.getString("exp_date");
				type = rs.getString("type");
				amount =rs.getInt("amount");
				min_basic =rs.getInt("min_basic");
				max_basic =rs.getInt("max_basic");
				min_amount =rs.getInt("min_amt");
				max_amount =rs.getInt("max_amt");
				prop_yn = rs.getString("prop_yn");
				
				//sql1 = "SELECT count(*) FROM payrparm WHERE prd_code = ? and var_name = ? ";
				sql1 ="SELECT count(*) FROM GRADE_MTHAD WHERE PAY_TABLE = ? and GRADE_CODE=? AND MONTH_CODE=? AND AD_CODE=? AND EFF_DATE=?";
				pstmt1 =  conn.prepareStatement(sql1);
				pstmt1.setString(1, new_pay_table);
				pstmt1.setString(2, new_grade_code);
				pstmt1.setString(3, new_month_code);
				pstmt1.setString(4, ad_code);
				java.sql.Timestamp effDateChg = null;
				effDateChg=getTimestamp(eff_date);
				pstmt1.setTimestamp(5, effDateChg);
				rs1 = pstmt1.executeQuery();
				if(rs1.next())
				{
					cnt =  rs1.getInt(1);

				}
				rs1.close();
				rs1 = null;
				pstmt1.close();
				pstmt1 = null;
				System.out.println("@@@@@:::cnt:["+cnt+"]");
				if(cnt == 0)
				{
					sqlInser = "INSERT INTO GRADE_MTHAD  ( pay_table, grade_code, month_code, ad_code, eff_date, exp_date, type, amount, min_basic, max_basic, min_amt, max_amt, prop_yn, chg_date, chg_user, chg_term) "
						       +" VALUES (?,?,?, ?,?,?, ?,?,?, ?,?,?,?,?,?,?)  ";
					pstmtInser	= conn.prepareStatement(sqlInser);
					pstmtInser.setString(1,new_pay_table);
					pstmtInser.setString(2, new_grade_code);
					pstmtInser.setString(3, new_month_code);
					pstmtInser.setString(4, ad_code );
					pstmtInser.setString(5, getDD_MM_YYYY_format(eff_date) );
					pstmtInser.setString(6, getDD_MM_YYYY_format(exp_date) ); 
					pstmtInser.setString(7, type );
					pstmtInser.setInt(8, amount );
					pstmtInser.setInt(9, min_basic );
					pstmtInser.setInt(10, max_basic );
					pstmtInser.setInt(11, min_amount);
					pstmtInser.setInt(12, max_amount);
					pstmtInser.setString(13, prop_yn );
					pstmtInser.setTimestamp(14,currDate);
					pstmtInser.setString(15,chgUser);
					pstmtInser.setString(16,chgTerm);
					
					 ///currAppdate
					/*pstmtInser.setString(7,chgUser);
					pstmtInser.setString(8,chgTerm);
					pstmtInser.setDouble(9,limit_hrs);
					pstmtInser.setString(10,limit_type);
					pstmtInser.setDouble(11,min_minutes);*/
					updCnt = pstmtInser.executeUpdate();
					pstmtInser.close();
					pstmtInser=null;
					if(updCnt > 0 )
					{
						conn.commit();
						System.out.println("@@@@@ Record inserted for table no["+new_pay_table +"]:::::::: @@@@@");
					}
				}
				else
				{
					//System.out.println("@@@@@ :::::Record already exist for PeriodCode["+newPeriodCode +"]::varName["+ varName +"]  :::::: @@@@@");
					//errString = itmDBAccessLocal.getErrorString("","VMDUPREC1","");
				}

			}
			if(rs != null)
			{
				rs.close();
				rs = null;
			}
			if(pstmt != null)
			{
				pstmt.close();
				pstmt = null;
			}
			}		
			//valueXmlString.append("</Root>\r\n");
		} // end of try 
		catch(Exception e)
		{
			try
			{
				conn.rollback();
			}
			catch(Exception ex)
			{
				throw new ITMException(ex);

			}
			throw new ITMException(e);

		}
		finally
		{
			try
			{
				conn.close();
				conn = null;
			}
			catch(Exception e)
			{
				throw new ITMException(e);
			}
		}
		return errString ;
	}
	
public String getDD_MM_YYYY_format(String str) throws Exception{
		
		  DateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
		  Date date;
		  String dd_mm_yyyy="";
	
			date = (Date)formatter.parse(str);
			System.out.println("DDMMYYYY="+date);
			SimpleDateFormat format = new SimpleDateFormat("dd-MMM-yyyy");   
			dd_mm_yyyy=format.format(date);
			
	       //String orcleFormat= oracleFormatDate(dd_mm_yyyy); 
	       System.out.println("orcleFormat dd-mm-yyyy=="+dd_mm_yyyy);
	     return dd_mm_yyyy;
	}
	
public Timestamp getTimestamp(String str) throws Exception{
		
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss.S");
		java.util.Date date = sdf.parse(str);
		java.sql.Timestamp timestamp = new java.sql.Timestamp(date.getTime());
		//System.out.println("====="+timestamp);
		return timestamp;
		
	}

	
	
	public int checkValidity(String retrival, String column_name, String table_name,  Connection from_site_conn) throws SQLException{
		boolean flag=false;
		PreparedStatement pstmt=null;
		ResultSet rs=null;
		String Query="";
		Connection conn=null;
		int count=0;
		Connection localConnection =null;
			
		try{
			       conn = from_site_conn;
			       Query="select count("+column_name+")  from "+table_name+" where "+column_name+"='"+retrival+"'";
			       System.out.println("====QUERY=="+Query);
			       pstmt=conn.prepareStatement(Query);
			       rs=pstmt.executeQuery(Query);
			       if(rs.next()){
			    	   count=rs.getInt(1);
			       	}
			      
		 }catch(Exception e){
			 e.printStackTrace();
		 }finally{
			 if(pstmt!=null){
				 pstmt.close();
				 pstmt=null;
			 }
			 if(rs!=null){
				 rs.close();
				 rs=null;
			 }
			 		}
		 System.out.println("count="+count);
		return count;
		}

}



